<?php /*Finojaho Wordpress Theme*/

require_once('ads.php');

function init_language(){
	if (class_exists('xili_language')) {
		define('THEME_TEXTDOMAIN','finojaho');
		define('THEME_LANGS_FOLDER','/lang');
	} else {
	   load_theme_textdomain('finojaho', get_template_directory() . '/lang');
	}
}

add_action ('init', 'init_language'); 
add_action('widgets_init','unregister_problem_widgets',99); 
add_action('admin_menu', 'finojaho_options');
add_action( 'after_setup_theme', 'finojaho_theme_setup' );
wp_register_sidebar_widget(7000,'Finojaho: Categories', 'finojaho_CategoriesWidget');
wp_register_widget_control(7000,'Finojaho: Categories', 'finojaho_CategoriesWidgetAdmin');
wp_register_sidebar_widget(7001,'Finojaho: Archives', 'finojaho_ArchivesWidget');
wp_register_widget_control(7001,'Finojaho: Archives', 'finojaho_ArchivesWidgetAdmin');
wp_register_sidebar_widget(7002,'Finojaho: Pages', 'finojaho_PagesWidget');
wp_register_widget_control(7002,'Finojaho: Pages', 'finojaho_PagesWidgetAdmin');
wp_register_sidebar_widget(7003,'Finojaho: Recent Post', 'finojaho_RecentPostWidget');
wp_register_widget_control(7003,'Finojaho: Recent Post', 'finojaho_RecentPostWidgetAdmin');
wp_register_sidebar_widget(7004,'Finojaho: Recent Comment', 'finojaho_RecentCommentWidget');
wp_register_widget_control(7004,'Finojaho: Recent Comment', 'finojaho_RecentCommentWidgetAdmin');
wp_register_sidebar_widget(7005,'Finojaho: FlickR', 'finojaho_FlickrWidget');
wp_register_widget_control(7005,'Finojaho: FlickR', 'finojaho_FlickrWidgetAdmin');
wp_register_sidebar_widget(7006,'Finojaho: Twitter', 'finojaho_TwitterWidget');
wp_register_widget_control(7006,'Finojaho: Twitter', 'finojaho_TwitterWidgetAdmin');
wp_register_sidebar_widget(7007,'Finojaho: Calendar', 'finojaho_CalendarWidget');
wp_register_widget_control(7007,'Finojaho: Calendar', 'finojaho_CalendarWidgetAdmin');


if ( !function_exists( 'finojaho_theme_setup' ) ):
  function finojaho_theme_setup(){
    add_theme_support( 'automatic-feed-links' );
    add_theme_support( 'menus' );
	
    function finojaho_nav_menu() {
      if ( function_exists( 'wp_nav_menu' ) )
        wp_nav_menu( array(
                           'theme_location' => 'top-menu',
                           'depth' => 3,
                           'fallback_cb' => 'finojaho_list_pages'
                           ) );
      else
        finojaho_list_pages();      
    }
    
    function finojaho_list_pages() {
    	if (get_finojaho_option('finojaho_showpage') != 'no') {wp_list_pages('title_li=&depth=3');}
		else {wp_list_categories('title_li=&depth=3');}
    }
    
    add_action( 'init', 'register_finojaho_menu' );
	
    function register_finojaho_menu() {
      register_nav_menu( 'top-menu', __( 'Top Menu' ) );
    }
}
endif;

if ( ! isset( $content_width ) ) $content_width = 595;

//-------------------------------------------------------------------------

// finojaho settings value
$options = array (
	'finojaho_dropdowncat' => 'off',
	'finojaho_showcountcat' => 'on',	
	'finojaho_orderbycat' => 'name',
	'finojaho_hierachycat' => 'on',
	'finojaho_depthcat' => 'off',
	'finojaho_showslimcat' => 'on',
	'finojaho_titlecat' => '',
	'finojaho_showcountarc' => 'on',
	'finojaho_dropdownarc' => 'off',
	'finojaho_typearc' => 'monthly',
	'finojaho_showslimarc' => 'on',
	'finojaho_titlearc' => '',
	'finojaho_dropdownpag' => 'off',
	'finojaho_typepag' => 'post_title',
	'finojaho_showslimpag' => 'on',
	'finojaho_titlepag' => '',
	'finojaho_orderbypag' => 'asc',
	'finojaho_titlerec' => '',
	'finojaho_reccount' => '5',
	'finojaho_titlecom' => '',
	'finojaho_comcount' => '5',
	'finojaho_comlength' => '78',
	'finojaho_flickrid' => '',
	'finojaho_flickrpub' => 'yes',
	'finojaho_flickridpub' => 'cd+covers',
	'finojaho_titleflickr' => '',
	'finojaho_titletwit' => '',
	'finojaho_twitterid' => 'Wordpress',
	'finojaho_twitteren' => '5',
	'finojaho_titlecal' => '',
	'finojaho_visibleabo' => 'yes',
	'finojaho_titleabo' => 'About Me Sample Title',
	'finojaho_imgabo' => '',
	'finojaho_textabo' => __('This is a sample text about you. You may login and go to the Finojaho settings page and edit this text. Here you can display a summary of your website or anything that is interesting to your visitors. You also can disable this section completely. You have full control thru the settings page.', 'finojaho'),
	'finojaho_visibleads' => 'no',
	'finojaho_nofollowads' => 'yes',
	'finojaho_numberads' => '2',
	'finojaho_adsimgurl1' => '',
	'finojaho_adsadurl1' => '#',
	'finojaho_adsalt1' => __('Sample Ads 1 ALT text','finojaho'),
	'finojaho_adsimgurl2' => '',
	'finojaho_adsadurl2' => '#',
	'finojaho_adsalt2' => __('Sample Ads 2 ALT text','finojaho'),
	'finojaho_visiblerrscom' => 'yes',
	'finojaho_visiblerss' => 'yes',
	'finojaho_rssurl' => '',
	'finojaho_showpage' => 'yes',
	'finojaho_search' => 'yes',
	'finojaho_searchid' => '',
	'finojaho_showads' => 'no',
	'finojaho_adsenseid' => '',
	'finojaho_reltag' => '10',
	'finojaho_relcat' => '10'                                                         
);

// set options value
	$isitavailable = get_option('finojaho');
	if ( $isitavailable === FALSE || $isitavailable == null ) {
		update_option('finojaho', $options);
	}

$uploadpath = wp_upload_dir();
if ($uploadpath['baseurl']=='') $uploadpath['baseurl'] = get_bloginfo('siteurl').'/wp-content/uploads';

//-------------------------------------------------------------------------

function get_finojaho_option( $option ) {
  $get_finojaho_options = get_option('finojaho');
  return $get_finojaho_options[$option];
}

//-------------------------------------------------------------------------

function finojaho_options() {
  global $options, $uploadpath, $menu;

	if ( isset( $_GET['page'] ) && $_GET['page'] == 'finojaho-settings' && isset( $_REQUEST['action'] ) ) {
	if ( 'finojaho_save' == $_REQUEST['action'] ) {	
		check_admin_referer();
		if (!current_user_can('manage_options')) wp_die(__('You do not have sufficient rights to edit the theme.', 'finojaho'));
		foreach ($options as $key => $value) { 
			if( isset( $_REQUEST[$key] )) { $options[$key] = stripslashes($_REQUEST[ $key ]); } 
			}
		$num = get_finojaho_option('finojaho_numberads');
		for($i=1; $i<=$num; $i++) {
		if( !isset( $_REQUEST[ 'finojaho_adsimgurl'.$i ] )) {  } else { $options[ 'finojaho_adsimgurl'.$i ] = stripslashes($_REQUEST[ 'finojaho_adsimgurl'.$i ]); }
		if( !isset( $_REQUEST[ 'finojaho_adsadurl'.$i ] )) {  } else { $options[ 'finojaho_adsadurl'.$i ] = stripslashes($_REQUEST[ 'finojaho_adsadurl'.$i ]); }
		if( !isset( $_REQUEST[ 'finojaho_adsalt'.$i ] )) {  } else { $options[ 'finojaho_adsalt'.$i ] = stripslashes($_REQUEST[ 'finojaho_adsalt'.$i ]); } 
		}
	
		if ($_FILES["file-header"]["type"]){
			$directory = $uploadpath['basedir'].'/';
			move_uploaded_file($_FILES["file-header"]["tmp_name"], $directory . $_FILES["file-header"]["name"]);
			$options['finojaho_imgabo'] = $uploadpath['baseurl']. "/". $_FILES["file-header"]["name"];
		}	
		
		update_option('finojaho', $options);
		wp_redirect("admin.php?page=finojaho-settings&saved=true");
		die;
	}
	}
  
	foreach ( $menu as $id => $data ) {
		if ( 0 == strcmp('wp-menu-separator-last', $data[4])) {	$menu[$id] = array( '', 'read', 'separator3', '', 'wp-menu-separator' ); } 
		}  

	add_menu_page(__('Finojaho Settings','finojaho'), 'Finojaho', 'manage_options', 'finojaho-settings', 'finojaho_admin');
	add_submenu_page('finojaho-settings',__('Finojaho Settings','finojaho'), __('Finojaho Settings','finojaho'), 'manage_options', 'finojaho-settings', 'finojaho_admin');
	add_submenu_page('finojaho-settings',__('Widgets','finojaho'), __('Widgets','finojaho'), 'manage_options', 'widgets.php');
}


//-------------------------------------------------------------------------


function finojaho_admin() {
    global $options, $uploadpath;
	
	
?>
<div class="wrap">

	<div id="icon-options-general" class="icon32"><br /></div>
	<h2 class="alignleft"><?php _e('Finojaho Settings','finojaho');?>
	<small><small><a style="margin-left:5px; color:#FF6600; text-decoration:none;" href="http://www.hulozila.com/"><?php _e('Visit Finojaho Homepage','finojaho'); ?></a></small></small></h2>
  	<br clear="all" />
  	<?php if ( isset($_REQUEST['saved']) && $_REQUEST['saved'] == '1' ) { ?><div id="message" class="updated fade"><p><strong><?php _e('Settings saved.','finojaho'); ?></strong></p></div><?php } ?>	


<form method="post" id="myForm" enctype="multipart/form-data">
<?php wp_nonce_field(); ?>
	<div id="poststuff" class="metabox-holder">
		
		
		
		<div class="stuffbox">
  			<h3><label><?php _e('About Me Section (Sidebar)','finojaho'); ?></label></h3>
  			<div class="inside">
				<table class="form-table">
				<tr>
				<th scope="row"><?php _e('Visible?','finojaho'); ?></th>
				<td>
				<label><input  name="finojaho_visibleabo" id="finojaho_visibleabo" type="radio" value="yes" <?php if (get_finojaho_option('finojaho_visibleabo') == "yes") {echo "checked";} ?> /><?php _e('Yes','finojaho'); ?></label>

         		&nbsp;&nbsp;
				
        		<label><input  name="finojaho_visibleabo" id="finojaho_visibleabo" type="radio" value="no" <?php if (get_finojaho_option('finojaho_visibleabo') == "no") {echo "checked";} ?> /><?php _e('No','finojaho'); ?></label>
				</td>
				</tr>
				<tr>
				<th scope="row"><?php _e('Title','finojaho'); ?></th>
				<td><input class="widefat" name="finojaho_titleabo" id="finojaho_titleabo" type="text" size="100%" value="<?php echo get_finojaho_option('finojaho_titleabo'); ?>" /></td>
				</tr>
				<tr>
				<th scope="row"><?php _e('Image','finojaho'); ?></th>
				<td>
				<?php if(is_writable($uploadpath['basedir'])) { ?>
				<?php _e('Best size is 75px by 75px. Larger or smaller image will be resized to 75px by 75px.','finojaho'); ?><br />
				<input type="file" name="file-header" id="file-header" size="100%" />
				<br />
				<?php if(get_finojaho_option('finojaho_imgabo')) { echo '<div><img src="'; echo get_finojaho_option('finojaho_imgabo'); echo '"  style="margin-top:10px; width:75px; height: 75px;" /></div>'; } ?>
				<?php } else {  ?>
				<em style="color:#FF0000"><?php printf(__('Can\'t upload the image! The directory %s is not writable!<br />Change directory permissions with CHMOD 755 or 777','finojaho'), $uploadpath['baseurl']); ?></em>
				<?php }  ?>

				</td>
				</tr>
				<tr>
				<th scope="row"><?php _e('Text','finojaho'); ?></th>
				<td><textarea rows="7" cols="100%" name="finojaho_textabo" id="finojaho_textabo" class="widefat" style="overflow: auto;"><?php print get_finojaho_option('finojaho_textabo'); ?></textarea></td>
				</tr>
				</table>	<!-- close table -->
			</div>	<!-- close div.inside -->
		</div>	<!-- close div.stuffbox -->
		
		
		
		
		
		<div class="stuffbox">
  			<h3><label><?php _e('Ads: 125 Banner On Sidebar','finojaho'); ?></label></h3>
  			<div class="inside">
				<table class="form-table">
				<tr>
				<th scope="row"><?php _e('Visible?','finojaho'); ?></th>
				<td>
				<label><input  name="finojaho_visibleads" id="finojaho_visibleads" type="radio" value="yes" <?php if (get_finojaho_option('finojaho_visibleads') == "yes") {echo "checked";} ?> /><?php _e('Yes','finojaho'); ?></label>

         		&nbsp;&nbsp;
				
        		<label><input  name="finojaho_visibleads" id="finojaho_visibleads" type="radio" value="no" <?php if (get_finojaho_option('finojaho_visibleads') == "no") {echo "checked";} ?> /><?php _e('No','finojaho'); ?></label>
				</td>
				</tr>
				<tr>
				<th scope="row"><?php _e('Use Nofollow? <i>Default: Yes</i>','finojaho'); ?></th>
				<td>
				<label><input  name="finojaho_nofollowads" id="finojaho_nofollowads" type="radio" value="yes" <?php if (get_finojaho_option('finojaho_nofollowads') == "yes") {echo "checked";} ?> /><?php _e('Yes','finojaho'); ?></label>

         		&nbsp;&nbsp;
				
        		<label><input  name="finojaho_nofollowads" id="finojaho_nofollowads" type="radio" value="no" <?php if (get_finojaho_option('finojaho_nofollowads') == "no") {echo "checked";} ?> /><?php _e('No','finojaho'); ?></label>
				</td>
				</tr>
				<tr>
				<th scope="row"><?php _e('Number of Ads','finojaho'); ?></th>
				<td><input name="finojaho_numberads" id="finojaho_numberads" type="text" size="100%" value="<?php echo get_finojaho_option('finojaho_numberads'); ?>" class="widefat" /><br /><br /><br /></td>
				</tr>
				<?php
				$num = get_finojaho_option('finojaho_numberads');
				for($i=1; $i<=$num; $i++) { ?>
					
					<tr>
					<th scope="row"><?php _e('Advertiser','finojaho'); echo ' '.$i; ?></th>
					<td>
					<label><?php _e('Image URL: <i>Image source file</i>','finojaho'); ?><input name="finojaho_adsimgurl<?php echo $i; ?>" id="finojaho_adsimgurl<?php echo $i; ?>" type="text" size="100%" value="<?php echo get_finojaho_option('finojaho_adsimgurl'.$i); ?>" class="widefat" /></label> <br /><br />
					<label><?php _e('Ad URL: <i>URL of advertising website</i>','finojaho'); ?><input name="finojaho_adsadurl<?php echo $i; ?>" id="finojaho_adsadurl<?php echo $i; ?>" type="text" size="100%" value="<?php echo get_finojaho_option('finojaho_adsadurl'.$i); ?>" class="widefat" /></label> <br /><br />
					<label><?php _e('Image alt title: <i>Image description on mouse over</i>','finojaho'); ?><input name="finojaho_adsalt<?php echo $i; ?>" id="finojaho_adsalt<?php echo $i; ?>" type="text" size="100%" value="<?php echo get_finojaho_option('finojaho_adsalt'.$i); ?>" class="widefat" /></label> <br /><br /><br /><br />
					</td>
					</tr>
					
				<?php } ?>
				</table>	<!-- close table -->
			</div>	<!-- close div.inside -->
		</div>	<!-- close div.stuffbox -->
		
		
		
		
		
		<div class="stuffbox">
  			<h3><label><?php _e('Extra Settings','finojaho'); ?></label></h3>
  			<div class="inside">
				<table class="form-table">
				<tr>
				<th scope="row"><?php _e('Display RSS Comments Icon','finojaho'); ?></th>
				<td>
				<label><input  name="finojaho_visiblerrscom" id="finojaho_visiblerrscom" type="radio" value="yes" <?php if (get_finojaho_option('finojaho_visiblerrscom') == "yes") {echo "checked";} ?> /><?php _e('Yes','finojaho'); ?></label>

         		&nbsp;&nbsp;
				
        		<label><input  name="finojaho_visiblerrscom" id="finojaho_visiblerrscom" type="radio" value="no" <?php if (get_finojaho_option('finojaho_visiblerrscom') == "no") {echo "checked";} ?> /><?php _e('No','finojaho'); ?></label>
				</td>
				</tr>
				<tr>
				<th scope="row"><?php _e('Display RSS Icon','finojaho'); ?></th>
				<td>
				<label><input  name="finojaho_visiblerss" id="finojaho_visiblerss" type="radio" value="yes" <?php if (get_finojaho_option('finojaho_visiblerss') == "yes") {echo "checked";} ?> /><?php _e('Yes','finojaho'); ?></label>

         		&nbsp;&nbsp;
				
        		<label><input  name="finojaho_visiblerss" id="finojaho_visiblerss" type="radio" value="no" <?php if (get_finojaho_option('finojaho_visiblerss') == "no") {echo "checked";} ?> /><?php _e('No','finojaho'); ?></label>
				<br />
				<label><?php _e('Custom RSS Url:  <i>Please use full url, including http://</i>','finojaho'); ?>
				<input class="widefat" name="finojaho_rssurl" id="finojaho_rssurl" type="text" size="100%" value="<?php echo get_finojaho_option('finojaho_rssurl'); ?>"  /><i><?php _e('Default value is ->','finojaho'); echo ' '; bloginfo('rss2_url'); ?></i></label>
				<br />
				<br />
				</td>
				</tr>
				<tr>
				<th scope="row"><?php _e('Top Level Nagivation','finojaho'); ?></th>
				<td>
				<label><input  name="finojaho_showpage" id="finojaho_showpage" type="radio" value="yes" <?php if (get_finojaho_option('finojaho_showpage') == "yes") {echo "checked";} ?> /><?php _e('Show Pages <i>(Default)</i>','finojaho'); ?></label>

         		&nbsp;&nbsp;
				
        		<label><input  name="finojaho_showpage" id="finojaho_showpage" type="radio" value="no" <?php if (get_finojaho_option('finojaho_showpage') == "no") {echo "checked";} ?> /><?php _e('Show Categories','finojaho'); ?></label>
				<br />
				<br />
				</td>
				</tr>
				<tr>
				<th scope="row"><?php _e('Website Search Using?','finojaho'); ?></th>
				<td>
				<label><input  name="finojaho_search" id="finojaho_search" type="radio" value="yes" <?php if (get_finojaho_option('finojaho_search') == "yes") {echo "checked";} ?> /><?php _e('Default: Wordpress','finojaho'); ?></label>

         		&nbsp;&nbsp;
				
        		<label><input  name="finojaho_search" id="finojaho_search" type="radio" value="no" <?php if (get_finojaho_option('finojaho_search') == "no") {echo "checked";} ?> /><?php _e('Others: Google','finojaho'); ?></label>
				<br />
				<label><?php _e('If you selected Others (Google), please enter your publisher ID:','finojaho'); ?> 
				<input name="finojaho_adsenseid" id="finojaho_adsenseid" type="text" value="<?php echo get_finojaho_option('finojaho_adsenseid'); ?>"  /><br /><i><?php _e('Example -> 1234567890123456','finojaho'); ?></i><br /></label><br />
				</td>
				</tr>
				<tr>
				<th scope="row"><?php _e('Related Tags','finojaho'); ?></th>
				<td>
				<label><?php _e('Maximum number of post to show:','finojaho'); ?> 
				<input name="finojaho_reltag" id="finojaho_reltag" type="text" size="3" value="<?php echo get_finojaho_option('finojaho_reltag'); ?>"  /> <i><?php _e('Set to 0 for unlimited post','finojaho'); ?></i></label><br /><br />
				</td>
				</tr>
				<tr>
				<th scope="row"><?php _e('Related Categories','finojaho'); ?></th>
				<td>
				<label><?php _e('Maximum number of post to show:','finojaho'); ?> 
				<input name="finojaho_relcat" id="finojaho_relcat" type="text" size="3" value="<?php echo get_finojaho_option('finojaho_relcat'); ?>"  /> <i><?php _e('Set to 0 for unlimited post','finojaho'); ?></i></label><br /><br />
				</td>
				</tr>
				</table>	<!-- close table -->
			</div>	<!-- close div.inside -->
		</div>	<!-- close div.stuffbox -->
		
		
		
		
		
		<div class="stuffbox">
  			<h3><label><?php _e('Third Party Ads (Example: Google Adsense, Abdbrite etc) ','finojaho'); ?></label></h3>
  			<div class="inside">
				<table class="form-table">
				<tr>
				<th scope="row"><?php _e('Visible?','finojaho'); ?></th>
				<td>
				<label><input  name="finojaho_showads" id="finojaho_showads" type="radio" value="yes" <?php if (get_finojaho_option('finojaho_showads') == "yes") {echo "checked";} ?> /><?php _e('Yes','finojaho'); ?></label>

         		&nbsp;&nbsp;
				
        		<label><input  name="finojaho_showads" id="finojaho_showads" type="radio" value="no" <?php if (get_finojaho_option('finojaho_showads') == "no") {echo "checked";} ?> /><?php _e('No','finojaho'); ?></label>
				<br />
				<label><?php printf(__('To manually paste the adsense code OR other advertising code, paste code in the <b>ads.php</b> file in theme editor <a href="%s">here</a>.','finojaho'),'theme-editor.php'); ?></label>
				</td>
				</tr>
				</table>	<!-- close table -->
			</div>	<!-- close div.inside -->
		</div>	<!-- close div.stuffbox -->	
	</div>	<!-- close div.poststuff -->	
	
<input name="finojaho_save" type="submit" class="button-primary" value="Save changes" />
<input type="hidden" name="action" value="finojaho_save" />	
</form>	<!-- close div.form -->

</div> 	<!-- close div.wrap -->


<!-- donation -->
<div class="wrap" style="background:#E3E3E3; margin:20px 15px 20px 0;">
	<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
		<table class="form-table">
			<tbody>
				<tr>
					<th scope="row" style="font-size:11px;">Donation</th>
					<td>
						If you like the theme, please consider to donate.
						<br />
						<input type="hidden" name="cmd" value="_s-xclick">
						<input type="hidden" name="hosted_button_id" value="8BJSSG8D8NYE6">
						<input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donate_SM.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
						<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
					</td>
				</tr>
			</tbody>
		</table>	
	</form>
</div>





<?php }

//-------------------------------------------------------------------------


if ( function_exists('register_sidebar') )
    register_sidebar(array(
		'name' => 'Default sidebar',
        'before_widget' => '<div class="sidebaritemrec %2$s"><li>',
        'after_widget' => '</li></div>',
        'before_title' => '<h3>',
        'after_title' => '</h3>',
    ));





//-------------------------------------------------------------------------


// Categories Widget
function finojaho_CategoriesWidget($args){
 extract($args);
 echo '<div class="sidebaritem"><li>';

?>
 <!-- sidebar categories -->

 	<?php 
	if (get_finojaho_option('finojaho_showcountcat')=='on') {$showcountcat = '1';} else {$showcountcat = '0';}
	if (get_finojaho_option('finojaho_hierachycat')=='on') {$hierachycat = '1';} else {$hierachycat = '0';}
	if (get_finojaho_option('finojaho_depthcat')=='on') {$depthcat = '1';} else {$depthcat = '0';}
	if (get_finojaho_option('finojaho_showslimcat')=='on') {$showslimcat = '1';} else {$showslimcat = '0';}
	
	if(get_finojaho_option('finojaho_dropdowncat')=='on'){
		if ((get_finojaho_option('finojaho_orderbycat')=='id') || (get_finojaho_option('finojaho_orderbycat')=='name')) { $orderby = get_finojaho_option('finojaho_orderbycat'); } else { $orderby = 'id'; }
		if (get_finojaho_option('finojaho_titlecat') == '') {$temptitle = __('Browse Categories','finojaho');} else {$temptitle = get_finojaho_option('finojaho_titlecat');}
		$variable = wp_list_categories('echo=0&show_count='.$showcountcat.'&orderby='.$orderby.'&hierarchical='.$hierachycat.'&depth='.$depthcat.'&title_li='); 
		if ($showcountcat == '1') {
			if (strpos($variable,'</a> (')) $variable = str_replace(array('</a> (',')'), array(' <p>(',')</p></a>'), $variable);
			if (strpos($variable,'</a>&nbsp;(')) $variable = str_replace(array('</a>&nbsp;(',')'), array(' <p>(',')</p></a>'), $variable);
			}
		if ($showslimcat == '0') echo $before_title;
		if ($showslimcat == '0') {
			if (get_finojaho_option('finojaho_titlecat') == '') {_e('Categories','finojaho');} 
			else {echo get_finojaho_option('finojaho_titlecat');}}
		if ($showslimcat == '0') echo $after_title.'<ul>';
		
		
		if ($showslimcat == '1') echo '<ul><div class="slidedown">';		
		if ($showslimcat == '1') {
			if (get_finojaho_option('finojaho_titlecat') == '') { echo '<a class="dropdowncat">'.$temptitle.'</a>'; } 
			else {echo '<a class="dropdowncat">'.$temptitle.'</a>';}}	 
		
		
		if ($showslimcat == '0') echo '<div class="dropdownlist">';		
		if ($showslimcat == '0') {
			if (get_finojaho_option('finojaho_titlecat') == '') { echo '<a class="dropdowncat">'.$temptitle.'</a>'; } 
			else {echo '<a class="dropdowncat">'.$temptitle.'</a>';}}
						
			
		echo '<div class="slidedownitemcat">';
		echo $variable;	
		echo '</div>';
		echo '</div>';	
		

		
	} else {
		$orderby = get_finojaho_option('finojaho_orderbycat');
		$variable = wp_list_categories('echo=0&show_count='.$showcountcat.'&orderby='.$orderby.'&hierarchical='.$hierachycat.'&depth='.$depthcat.'&title_li='); 
		if ($showcountcat == '1') {
			$sea = array('(0 )','(1 )');
			$rep = array('(0 '.__('Post','finojaho').')','(1 '.__('Post','finojaho').')');
			$variable = str_replace(')',' )',$variable);
			if (strpos($variable,'(1 )') || strpos($variable,'(0 )')) {$variable = str_replace($sea,$rep,$variable); $variable = str_replace(' )',' '.__('Posts','finojaho').')',$variable);} else {str_replace(' )',' '.__('Posts','finojaho').')',$variable);}
			if (strpos($variable,'</a> (')) $variable = str_replace(array('</a> (',')'), array(' <p>(',')</p></a>'), $variable);
			if (strpos($variable,'</a>&nbsp;(')) $variable = str_replace(array('</a>&nbsp;(',')'), array(' <p>(',')</p></a>'), $variable);
			}
		echo $before_title;
		if (get_finojaho_option('finojaho_titlecat') == '') { _e('Categories','finojaho'); } else {echo get_finojaho_option('finojaho_titlecat');} 
		echo $after_title.'<ul>';
		echo $variable;	
		
	}?>	
	
   <?php if (function_exists('xili_language_list')) { xili_language_list(); } ?>

  <!-- /sidebar categories -->
 <?php
 echo '</ul>'.$after_widget;
}

//-------------------------------------------------------------------------

//Categories widget admin control
function finojaho_CategoriesWidgetAdmin() {
  // update the options
  if (isset($_POST['update_widgetoptions'])) {
  	$newoptions = get_option('finojaho');
	foreach ($newoptions as $key => $value) { if (isset($_POST[$key])) { $newoptions[$key] = strip_tags(stripslashes($_POST[$key])); } }
	if (!isset($_POST['finojaho_dropdowncat'])) $newoptions['finojaho_dropdowncat'] = 'off'; 
	if (!isset($_POST['finojaho_hierachycat'])) $newoptions['finojaho_hierachycat'] = 'off'; 
	if (!isset($_POST['finojaho_showcountcat'])) $newoptions['finojaho_showcountcat'] = 'off'; 
	if (!isset($_POST['finojaho_depthcat'])) $newoptions['finojaho_depthcat'] = 'off'; 
	if (!isset($_POST['finojaho_showslimcat'])) $newoptions['finojaho_showslimcat'] = 'off'; 
	update_option('finojaho', $newoptions);
  }
?>
  <p><label><?php _e('Title:','finojaho'); ?></label> 
  	<input name="finojaho_titlecat" id="finojaho_titlecat" type="text" value="<?php echo get_finojaho_option('finojaho_titlecat'); ?>" class="widefat" /></p>
  <p><label><?php _e('Sort categories by:','finojaho'); ?>
    <select style="width: 100%;" name="finojaho_orderbycat" id="finojaho_orderbycat" class="widefat">
	<option <?php if (get_finojaho_option('finojaho_orderbycat')=='name') {?> selected="selected" <?php } ?> value="name"><?php _e('Alphabetically (Default)','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_orderbycat')=='id') {?> selected="selected" <?php } ?> value="id"><?php _e('Unique category ID','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_orderbycat')=='slug') {?> selected="selected" <?php } ?> value="slug"><?php _e('Category slug','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_orderbycat')=='count') {?> selected="selected" <?php } ?> value="count"><?php _e('Post count','finojaho'); ?></option>
    </select>
  </label></p>
  <br />
 
  <label><input name="finojaho_dropdowncat" id="finojaho_dropdowncat" type="checkbox" <?php if (get_finojaho_option('finojaho_dropdowncat')=='on') { echo " checked"; } ?> /><?php _e('Show as dropdown list','finojaho'); ?></label><br />  
  <label><input name="finojaho_hierachycat" id="finojaho_hierachycat" type="checkbox" <?php if (get_finojaho_option('finojaho_hierachycat')=='on') { echo " checked"; } ?> /><?php _e('Show category hierachy','finojaho'); ?></label><br />
  <label><input name="finojaho_showcountcat" id="finojaho_showcountcat" type="checkbox" <?php if (get_finojaho_option('finojaho_showcountcat')=='on') { echo " checked"; } ?> /><?php _e('Show category post count','finojaho'); ?></label><br />
  <label><input name="finojaho_depthcat" id="finojaho_depthcat" type="checkbox" <?php if (get_finojaho_option('finojaho_depthcat')=='on') { echo " checked"; } ?> /><?php _e('Show only top level categories','finojaho'); ?></label><br />
 <label><input name="finojaho_showslimcat" id="finojaho_showslimcat" type="checkbox" <?php if (get_finojaho_option('finojaho_showslimcat')=='on') { echo " checked"; } ?> /><?php _e('Show dropdown list without title','finojaho'); ?></label><br /> 
  
  
  
  <input type="hidden" id="update_widgetoptions" name="update_widgetoptions" value="1" />
<?php
}


//-------------------------------------------------------------------------


// Archives Widget
function finojaho_ArchivesWidget($args){
 extract($args);
 echo '<div class="sidebaritem"><li>';
?>
 <!-- sidebar archives -->

 	<?php 
	if (get_finojaho_option('finojaho_showcountarc')=='on') {$showcountarc = '1';} else {$showcountarc = '0';}
	if (get_finojaho_option('finojaho_showslimarc')=='on') {$showslimarc = '1';} else {$showslimarc = '0';}
	
	if(get_finojaho_option('finojaho_dropdownarc')=='on'){
		$variable = wp_get_archives('echo=0&type='.get_finojaho_option('finojaho_typearc').'&format=html&show_post_count='.get_finojaho_option('finojaho_showcountarc')); 
		if ($showcountarc == '1') {
			if (strpos($variable,'</a> (')) $variable = str_replace(array('</a> (',')'), array(' <p>(',')</p></a>'), $variable);
			if (strpos($variable,'</a>&nbsp;(')) $variable = str_replace(array('</a>&nbsp;(',')'), array(' <p>(',')</p></a>'), $variable);
			}
		if ($showslimarc == '0') echo $before_title;
		if ($showslimarc == '0') {
			if (get_finojaho_option('finojaho_titlearc') == '') {_e('Archives','finojaho'); } 
			else {echo get_finojaho_option('finojaho_titlearc');}}
		if ($showslimarc == '0') echo $after_title.'<ul>';
		
		
		if ($showslimarc == '1') echo '<ul><div class="slidedown">';		
		if ($showslimarc == '1') {
			if (get_finojaho_option('finojaho_titlearc') == '') { echo '<a class="dropdownarc">'.get_finojaho_option('finojaho_typearc').' '.__('Archives','finojaho').'</a>'; }
			else {echo '<a class="dropdownarc">'.get_finojaho_option('finojaho_titlearc').'</a>';}}	 
		
		
		if ($showslimarc == '0') echo '<div class="dropdownlist">';		
		if ($showslimarc == '0') {
			if (get_finojaho_option('finojaho_titlearc') == '') { echo '<a class="dropdownarc">'.get_finojaho_option('finojaho_typearc').' '.__('Archives','finojaho').'</a>'; }
			else {echo '<a class="dropdownarc">'.get_finojaho_option('finojaho_titlearc').'</a>';}}
						
			
		echo '<div class="slidedownitemarc">';
		echo $variable;	
		echo '</div>';
		echo '</div>';	
	
	

	} else {
		$variable = wp_get_archives('echo=0&type='.get_finojaho_option('finojaho_typearc').'&format=html&show_post_count='.get_finojaho_option('finojaho_showcountarc')); 
		if ($showcountarc == '1') {
			$sea = array('(0 )','(1 )');
			$rep = array('(0 '.__('Post','finojaho').')','(1 '.__('Post','finojaho').')');
			$variable = str_replace(')',' )',$variable);
			if (strpos($variable,'(1 )') || strpos($variable,'(0 )')) {$variable = str_replace($sea,$rep,$variable); $variable = str_replace(' )',' '.__('Posts','finojaho').')',$variable);} else {str_replace(' )',' '.__('Posts','finojaho').')',$variable);}
			if (strpos($variable,'</a> (')) $variable = str_replace(array('</a> (',')'), array(' <p>(',')</p></a>'), $variable);
			if (strpos($variable,'</a>&nbsp;(')) $variable = str_replace(array('</a>&nbsp;(',')'), array(' <p>(',')</p></a>'), $variable);
			}	
	  	echo $before_title;
		if (get_finojaho_option('finojaho_titlearc') == '') { _e('Archives','finojaho'); } else {echo get_finojaho_option('finojaho_titlearc');};
		echo $after_title.'<ul>';
		echo $variable;	
	}?>	
	
   <?php if (function_exists('xili_language_list')) { xili_language_list(); } ?>

  <!-- /sidebar archives -->
 <?php
 echo '</ul>'.$after_widget;
}


//-------------------------------------------------------------------------


//Archives widget admin control
function finojaho_ArchivesWidgetAdmin() {
  // update the options
  if (isset($_POST['update_widgetoptions'])) {
  	$newoptions = get_option('finojaho');
	foreach ($newoptions as $key => $value) { if (isset($_POST[$key])) { $newoptions[$key] = strip_tags(stripslashes($_POST[$key])); } }
	if (!isset($_POST['finojaho_dropdownarc'])) $newoptions['finojaho_dropdownarc'] = 'off';
	if (!isset($_POST['finojaho_showcountarc'])) $newoptions['finojaho_showcountarc'] = 'off';
	if (!isset($_POST['finojaho_showslimarc'])) $newoptions['finojaho_showslimarc'] = 'off'; 
	update_option('finojaho', $newoptions);
  }
?>
  <p><label><?php _e('Title:','finojaho'); ?></label> 
  	<input name="finojaho_titlearc" id="finojaho_titlearc" type="text" value="<?php echo get_finojaho_option('finojaho_titlearc'); ?>" class="widefat" /></p>
  <p><label><?php _e('Show archives by:','finojaho'); ?>
    <select style="width: 100%;" name="finojaho_typearc" id="finojaho_typearc" class="widefat">
	<option <?php if (get_finojaho_option('finojaho_typearc')=='monthly') {?> selected="selected" <?php } ?> value="monthly"><?php _e('Monthly (Default)','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_typearc')=='yearly') {?> selected="selected" <?php } ?> value="yearly"><?php _e('Yearly','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_typearc')=='weekly') {?> selected="selected" <?php } ?> value="weekly"><?php _e('Weekly','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_typearc')=='daily') {?> selected="selected" <?php } ?> value="daily"><?php _e('Daily','finojaho'); ?></option>
    </select>
  </label></p>
  <br />

  <label><input name="finojaho_dropdownarc" id="finojaho_dropdownarc" type="checkbox" <?php if (get_finojaho_option('finojaho_dropdownarc')=='on') { echo " checked"; } ?> /><?php _e('Show as dropdown list','finojaho'); ?></label><br />
  <label><input name="finojaho_showcountarc" id="finojaho_showcountarc" type="checkbox" <?php if (get_finojaho_option('finojaho_showcountarc')=='on') { echo " checked"; } ?> /><?php _e('Show archives post count','finojaho'); ?></label><br />  
  <label><input name="finojaho_showslimarc" id="finojaho_showslimarc" type="checkbox" <?php if (get_finojaho_option('finojaho_showslimarc')=='on') { echo " checked"; } ?> /><?php _e('Show dropdown list without title','finojaho'); ?></label><br />
  
  <input type="hidden" id="update_widgetoptions" name="update_widgetoptions" value="1" />
<?php
}



//-------------------------------------------------------------------------


// Pages Widget
function finojaho_PagesWidget($args){
 extract($args);
 echo '<div class="sidebaritem"><li>';
?>
 <!-- sidebar pages -->

 	<?php 
	if (get_finojaho_option('finojaho_showslimpag')=='on') {$showslimpag = '1';} else {$showslimpag = '0';}
	
	if(get_finojaho_option('finojaho_dropdownpag')=='on'){
		$variable = wp_list_pages('echo=0&sort_column='.get_finojaho_option('finojaho_typepag').'&sort_order='.get_finojaho_option('finojaho_orderbypag').'&title_li=');

		if ($showslimpag == '0') echo $before_title;
		if ($showslimpag == '0') {
			if (get_finojaho_option('finojaho_titlepag') == '') { _e('Pages','finojaho'); } 
			else {echo get_finojaho_option('finojaho_titlepag');}}
		if ($showslimpag == '0') echo $after_title.'<ul>';
		
		
		if ($showslimpag == '1') echo '<ul><div class="slidedown">';		
		if ($showslimpag == '1') {
			if (get_finojaho_option('finojaho_titlepag') == '') { echo '<a class="dropdownpag">'.__('Browse Pages','finojaho').'</a>'; }
			else {echo '<a class="dropdownpag">'.get_finojaho_option('finojaho_titlepag').'</a>';}}	 
		
		
		if ($showslimpag == '0') echo '<div class="dropdownlist">';		
		if ($showslimpag == '0') {
			if (get_finojaho_option('finojaho_titlepag') == '') { echo '<a class="dropdownpag">'.__('Browse Pages','finojaho').'</a>'; }
			else {echo '<a class="dropdownpag">'.get_finojaho_option('finojaho_titlepag').'</a>';}}
						
			
		echo '<div class="slidedownitempag">';
		echo $variable;	
		echo '</div>';
		echo '</div>';	

	} else {
		$variable = wp_list_pages('echo=0&sort_column='.get_finojaho_option('finojaho_typepag').'&sort_order='.get_finojaho_option('finojaho_orderbypag').'&title_li='); 
	
	  	echo $before_title;
		if (get_finojaho_option('finojaho_titlepag') == '') { _e('Pages','finojaho'); } else {echo get_finojaho_option('finojaho_titlepag');};
		echo $after_title.'<ul>';
		echo $variable;	
	}?>	
	
   <?php if (function_exists('xili_language_list')) { xili_language_list(); } ?>

  <!-- /sidebar pages -->
 <?php
 echo '</ul>'.$after_widget;
}


//-------------------------------------------------------------------------


//Pages widget admin control
function finojaho_PagesWidgetAdmin() {
  // update the options
  if (isset($_POST['update_widgetoptions'])) {
  	$newoptions = get_option('finojaho');
	foreach ($newoptions as $key => $value) { if (isset($_POST[$key])) { $newoptions[$key] = strip_tags(stripslashes($_POST[$key])); } }
	if (!isset($_POST['finojaho_dropdownpag'])) $newoptions['finojaho_dropdownpag'] = 'off';
	if (!isset($_POST['finojaho_showslimpag'])) $newoptions['finojaho_showslimpag'] = 'off';
	update_option('finojaho', $newoptions);
  }
?>
  <p><label><?php _e('Title:','finojaho'); ?></label> 
  	<input name="finojaho_titlepag" id="finojaho_titlepag" type="text" value="<?php echo get_finojaho_option('finojaho_titlepag'); ?>" class="widefat" /></p>
  <p><label><?php _e('Sort pages by:','finojaho'); ?>
    <select style="width: 100%;" name="finojaho_typepag" id="finojaho_typepag" class="widefat">
	<option <?php if (get_finojaho_option('finojaho_typepag')=='post_title') {?> selected="selected" <?php } ?> value="post_title"><?php _e('Page Title (Default)','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_typepag')=='menu_order') {?> selected="selected" <?php } ?> value="menu_order"><?php _e('Admin Menu Order','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_typepag')=='post_date') {?> selected="selected" <?php } ?> value="post_date"><?php _e('Page Date','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_typepag')=='post_modified') {?> selected="selected" <?php } ?> value="post_modified"><?php _e('Page Modified','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_typepag')=='ID') {?> selected="selected" <?php } ?> value="ID"><?php _e('Page ID','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_typepag')=='post_author') {?> selected="selected" <?php } ?> value="post_author"><?php _e('Page Author','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_typepag')=='post_slug') {?> selected="selected" <?php } ?> value="post_slug"><?php _e('Page Slug','finojaho'); ?></option>
    </select>
  </label></p>
  <br />

<p><label><?php _e('Sort order:','finojaho'); ?>
    <select style="width: 100%;" name="finojaho_orderbypag" id="finojaho_orderbypag" class="widefat">
	<option <?php if (get_finojaho_option('finojaho_orderbypag')=='asc') {?> selected="selected" <?php } ?> value="asc"><?php _e('Ascending (Default)','finojaho'); ?></option>
	<option <?php if (get_finojaho_option('finojaho_orderbypag')=='desc') {?> selected="selected" <?php } ?> value="desc"><?php _e('Descending','finojaho'); ?></option>
    </select>
  </label></p>
  <br />
  
  <label><input name="finojaho_dropdownpag" id="finojaho_dropdownpag" type="checkbox" <?php if (get_finojaho_option('finojaho_dropdownpag')=='on') { echo " checked"; } ?> /><?php _e('Show as dropdown list','finojaho'); ?></label><br />
  <label><input name="finojaho_showslimpag" id="finojaho_showslimpag" type="checkbox" <?php if (get_finojaho_option('finojaho_showslimpag')=='on') { echo " checked"; } ?> /><?php _e('Show dropdown list without title','finojaho'); ?></label><br />
  
  <input type="hidden" id="update_widgetoptions" name="update_widgetoptions" value="1" />
<?php
}



//-------------------------------------------------------------------------



function finojaho_RecentPostWidget($args) {
 extract($args);
 echo $before_widget;
?>
 <!-- sidebar recent post -->

 	<?php
	echo $before_title;
	if (get_finojaho_option('finojaho_titlerec') == '') { _e('Recent Post','finojaho');} 
	else { echo get_finojaho_option('finojaho_titlerec');}
	echo $after_title.'<ul>'; 
    $recentPosts = new WP_Query();
    $recentPosts->query('showposts='.get_finojaho_option('finojaho_reccount'));
	while ($recentPosts->have_posts()) : $recentPosts->the_post(); ?>
		<li>
			<a href="<?php the_permalink() ?>" rel="bookmark"><?php the_title(); ?></a>
			<p class="mini"><?php printf(__('by %s with','finojaho'), '<a href="'. get_author_posts_url(get_the_author_meta('ID')) .'" title="'. sprintf(__("Posts by %s","finojaho"), esc_attr(get_the_author())).'">'. get_the_author() .'</a>');  echo ' <a href="'.get_comments_link().'">'; comments_number(__('No Comments','finojaho'), __('1 Comment','finojaho'), __('% Comments','finojaho')); echo '</a>'; ?></p>
			<?php 
			$post = get_post($post->post_ID,OBJECT);
			setup_postdata($post);
			/*http://co-opmedia.org/2009/04/12/auto-get-thumbnail-from-post/*/
			$size = 'thumbnail';
			$imginpost = get_the_content();
			$imginpost = do_shortcode($imginpost);
			if (isset($matches)) unset($matches);
			if (isset($match)) unset($match);
			if (isset($regs)) unset($regs);
			preg_match('/<img(.*?)src=["'."']".'(.*?)["'."']".'(.*?)\/\>/i', $imginpost, $matches);
			if ($matches) preg_match_all('/(alt|title)=("[^"]*")/i',$matches[0],$match);
			if (isset($match[0][0])) {$match[0][0] =' '.$match[0][0];} else {$match[0][0] = '';}
			if (isset($match[0][1])) {$match[0][1] =' '.$match[0][1];} else {$match[0][1] = '';}
			if ($matches) {
				ereg('wp-image-([0-9]+)',$matches[0],$regs);  
				if ($regs) {
					if (is_numeric($regs[1])) {
						$image = wp_get_attachment_image_src($regs[1], $size, false);
						if ($image) {
							$image = '<img src="'.esc_attr($image[0]).'" class="thumbpost"'.$match[0][0].$match[0][1].' />';
						} // if ($image)
					} // if (is_numeric($regs[1]))
				} // if ($regs)
				else {
					$image = '<img src="'.esc_attr($matches[2]).'" class="thumbpost"'.$match[0][0].$match[0][1].' />';
				}
			} // if ($matches)
			else { $image = '';}
			$shortpost = strip_shortcodes(get_the_content()); 
			$shortpost = strip_tags($shortpost);
			if (strlen($shortpost) <= 150 ) { echo '<p>'.$image.$shortpost.'</p>';}
			else  {$shortpost = substr($shortpost, 0, 150).'<small>...</small>'; echo '<p>'.$image.$shortpost.'</p>';}
			
			?>
		</li>
	<?php endwhile;?>
	
	
	
 <!-- /sidebar recent post -->
 <?php 
 echo '</ul>'.$after_widget;
}





//-------------------------------------------------------------------------



//Recent Post widget admin control
function finojaho_RecentPostWidgetAdmin() {
  // update the options
 if (isset($_POST['update_widgetoptions'])) {
  	$newoptions = get_option('finojaho');
	foreach ($newoptions as $key => $value) { if (isset($_POST[$key])) { $newoptions[$key] = strip_tags(stripslashes($_POST[$key])); } }
	update_option('finojaho', $newoptions);
  } 
?>
  <p><label><?php _e('Title:','finojaho'); ?></label> 
  	<input name="finojaho_titlerec" id="finojaho_titlerec" type="text" value="<?php echo get_finojaho_option('finojaho_titlerec'); ?>" class="widefat" /></p>

  <p><label><?php _e('Number of posts to show:','finojaho'); ?></label>
	<input name="finojaho_reccount" id="finojaho_reccount" type="text" value="<?php echo get_finojaho_option('finojaho_reccount'); ?>" size="3" />
	<br/>
	<small><?php _e('default is 5','finojaho'); ?></small></p>

  <input type="hidden" id="update_widgetoptions" name="update_widgetoptions" value="1" />
<?php
}




//-------------------------------------------------------------------------





function finojaho_RecentCommentWidget($args) {
 global $wpdb;
 extract($args);
 echo $before_widget;
?>
 <!-- sidebar recent comment -->

 	<?php
	$no_comments = get_finojaho_option('finojaho_comcount');
	$comment_len = get_finojaho_option('finojaho_comlength');
	echo $before_title;
	if (get_finojaho_option('finojaho_titlecom') == '') { echo 'Recent Comment';}
	else { echo get_finojaho_option('finojaho_titlecom');}
	echo $after_title.'<ul>'; 
    //as shown on http://www.wplancer.com/how-to-display-recent-comments-without-using-a-plugin-or-widget/
	$request = "SELECT * FROM $wpdb->comments";
	$request .= " JOIN $wpdb->posts ON ID = comment_post_ID";
	$request .= " WHERE comment_approved = '1' AND post_status = 'publish' AND post_password =''";
	$request .= " ORDER BY comment_date DESC LIMIT $no_comments";
	$comments = $wpdb->get_results($wpdb->prepare($request));
	if ($comments) {
		foreach ($comments as $comment) {
			ob_start();
			?>
				<li>
					<?php if (function_exists('get_avatar') && get_option('show_avatars')) {echo get_avatar($comment, 39);} ?>
					<a href="<?php echo get_comment_link( $comment->comment_ID ); ?>"><?php echo $comment->comment_author; ?>:</a>
					<?php echo '<p class="twitmini">'.__('Said on','finojaho').' '. mysql2date(get_option('date_format'),$comment->comment_date) . '</p>'; ?>
					
					<?php $comment_txt = strip_tags(apply_filters('get_comment_text', $comment->comment_content));
					if (strlen($comment_txt) <= $comment_len) { echo '<p class="twit">'.$comment_txt.'</p>';}
					else { echo '<p class="twit">'.substr($comment_txt,0,$comment_len).'...</p>';} ?>
				</li>
			<?php
			ob_end_flush();
		}
	} else {
		echo '<li> No comments </li>';
	}?>
	
	
 <!-- /sidebar recent comment -->
 <?php 
 echo '</ul>'.$after_widget;
}





//-------------------------------------------------------------------------




//Recent Comment widget admin control
function finojaho_RecentCommentWidgetAdmin() {
  // update the options
 if (isset($_POST['update_widgetoptions'])) {
	$newoptions = get_option('finojaho');
	foreach ($newoptions as $key => $value) { if (isset($_POST[$key])) { $newoptions[$key] = strip_tags(stripslashes($_POST[$key])); } }
	update_option('finojaho', $newoptions);
  } 
?>
  <p><label><?php _e('Title:','finojaho'); ?></label> 
  	<input name="finojaho_titlecom" id="finojaho_titlecom" type="text" value="<?php echo get_finojaho_option('finojaho_titlecom'); ?>" class="widefat" /></p>

  <p><label><?php _e('Number of comments to show:','finojaho'); ?></label>
	<input name="finojaho_comcount" id="finojaho_comcount" type="text" value="<?php echo get_finojaho_option('finojaho_comcount'); ?>" size="3" /></p>

  <p><label><?php _e('Length of comment to show:','finojaho'); ?></label>
	<input name="finojaho_comlength" id="finojaho_comlength" type="text" value="<?php echo get_finojaho_option('finojaho_comlength'); ?>" size="3" /></p>

  <input type="hidden" id="update_widgetoptions" name="update_widgetoptions" value="1" />
<?php
}





//-------------------------------------------------------------------------







// FlickR Widget
function finojaho_FlickrWidget($args){
 extract($args);
 echo '<div class="sidebaritem"><li>'; ?>
 <?php 
 echo $before_title;
 if (get_finojaho_option('finojaho_titleflickr') == '') {_e('FlickR Gallery','finojaho');}
 else {echo get_finojaho_option('finojaho_titleflickr');}
 echo $after_title.'<ul>'; ?>

 <div class="flickr">
 <div class="flickr-thumb">
 <?php
 if (get_finojaho_option('finojaho_flickrpub') == 'yes') { ?>
	
	<script type="text/javascript">
	/* <![CDATA[ */
	jQuery(function(){
	jQuery.getJSON("http://api.flickr.com/services/feeds/photos_public.gne?tags=<?php echo trim(get_finojaho_option('finojaho_flickridpub'));?>&tagmode=all&lang=en-us&format=json&jsoncallback=?", function(data){
	 jQuery.each(data.items, function(index, item){
	  jQuery("<img />").attr("src", item.media.m).addClass("thumb").appendTo(".flickr").wrap("<a href=\"" + item.link + "\"></a>");
	 });
	});
	});
	/* ]]> */
	</script>
 	<?php } 
 
 else {
	$username = get_finojaho_option('finojaho_flickrid');
	?>
	
	<script type="text/javascript">
	/* <![CDATA[ */
	jQuery(function(){
	jQuery.getJSON("http://api.flickr.com/services/feeds/photos_public.gne?ids=<?php echo trim(get_finojaho_option('finojaho_flickrid'));?>&lang=en-us&format=json&jsoncallback=?", function(data){
	 jQuery.each(data.items, function(index, item){
	  jQuery("<img />").attr("src", item.media.m).addClass("thumb").appendTo(".flickr").wrap("<a href=\"" + item.link + "\"></a>");
	 });
	});
	});
	/* ]]> */
	</script>
	<?php } ?>
 
</div>
</div>
 <?php
 echo '</ul>'.$after_widget;
}






//-------------------------------------------------------------------------



// FlickR Widget Admin
function finojaho_FlickrWidgetAdmin() {
  // check if anything's been sent
if (isset($_POST['update_widgetoptions'])) {
   	$newoptions = get_option('finojaho');
	foreach ($newoptions as $key => $value) { if (isset($_POST[$key])) { $newoptions[$key] = strip_tags(stripslashes($_POST[$key])); } }
	update_option('finojaho', $newoptions);
  }
  ?>
  <p><label><?php _e('Title:','finojaho'); ?></label> 
  	<input name="finojaho_titleflickr" id="finojaho_titleflickr" type="text" value="<?php echo get_finojaho_option('finojaho_titleflickr'); ?>" class="widefat" /></p> <br />
  <p><label><input  name="finojaho_flickrpub" id="finojaho_flickrpub" type="radio" value="no" <?php if (get_finojaho_option('finojaho_flickrpub') == "no") {echo "checked";} ?> /> <?php _e('Use Personal Gallery','finojaho'); ?></label><br />
  <small><?php _e('Enter your <a href="http://idgettr.com/" target="_blank">Flickr ID</a>:','finojaho'); ?></small>
   <input type="text" size="30" name="finojaho_flickrid" id="finojaho_flickrid" value="<?php print get_finojaho_option('finojaho_flickrid'); ?>" /></p><br /><br />
   

   <p>
   <label><input  name="finojaho_flickrpub" id="finojaho_flickrpub" type="radio" value="yes" <?php if (get_finojaho_option('finojaho_flickrpub') == "yes") {echo "checked";} ?> /> <?php _e('Use Public Gallery','finojaho'); ?></label><br />
   <small><?php _e('Enter tags:','finojaho'); ?></small>
   <input type="text" size="30" name="finojaho_flickridpub" id="finojaho_flickridpub" value="<?php print get_finojaho_option('finojaho_flickridpub') ?>" />
   <br />
   <small><?php _e("Only use '+' for each word seperator. Best results using only 2 keywords.<br /> Use only lower cases.","finojaho"); ?></small>
   <br />
   <small><?php _e('Example 1: cd+covers','finojaho'); ?></small>
   <br />
   <small><?php _e('Example 2: travel+pictures','finojaho'); ?></small></p><br />
  <input type="hidden" id="update_widgetoptions" name="update_widgetoptions" value="1" />
<?php
}



//-------------------------------------------------------------------------



// Twitter Widget

function finojaho_TwitterWidget($args){
 extract($args);
 echo $before_widget;
?>

	<?php
	$username = get_finojaho_option('finojaho_twitterid');
	$en = get_finojaho_option('finojaho_twitteren');
	if($username<>'') {
	$feed = file_get_contents("http://search.twitter.com/search.atom?q=from:" . $username . "&rpp=" . $en);
	$feed = str_replace("&lt;", "<", $feed);
	$feed = str_replace("&gt;", ">", $feed);
	$feed = str_replace("&quot;", '"', $feed);
	$clean = explode("<content type=\"html\">", $feed);
	
	$feed = file_get_contents("http://search.twitter.com/search?q=from:" . $username . "&rpp=" . $en);
	$cleantime = explode("<div class=\"info\">",$feed);
	
	$amount = count($clean) - 1;
	echo $before_title;
	if (get_finojaho_option('finojaho_titletwit') == '') { echo 'Twitter Update';}
	else { echo get_finojaho_option('finojaho_titletwit');}
	echo $after_title.'<ul>';  
	for ($i = 1; $i <= $amount; $i++) {
		$content = explode("</content>", $clean[$i]);
		$contenttime = explode("<span class=\"source\">", $cleantime[$i]);
		$regex_patternsrc = "/<twitter:source>(.*)<\/twitter:source>/";
		preg_match_all($regex_patternsrc,$clean[$i],$matchsrc);
		$regex_patternby = "/<name>(.*)\((.*)\)<\/name>/";
		preg_match_all($regex_patternby,$clean[$i],$matchby);
		$regex_patternuri = "/<uri>(.*)<\/uri>/";
		preg_match_all($regex_patternuri,$clean[$i],$matchuri);
		$regex_pattern = "/<link type=\"image\/png\" href=\"(.*)\" rel=\"image\"/";
		preg_match_all($regex_pattern,$clean[$i],$matches);
		print '<li>';
		echo '<img class="avatartwit" src="'.$matches[1][0].'" />';
		echo '<a href="'.$matchuri[1][0].'">'.$matchby[2][0].':</a>';
		echo '<p class="twitmini">'.$contenttime[0].' '.__('thru','finojaho').' '.$matchsrc[1][0].'</p>';
		print '<p class="twit">';
		echo str_replace('&apos','&#39',htmlspecialchars_decode($content[0],ENT_NOQUOTES));		
		print '</p>';
		print '</li>';
		}
	}

 echo '</ul>'.$after_widget;
}






//-------------------------------------------------------------------------




function finojaho_TwitterWidgetAdmin() {
	// check if anything's been sent
	if (isset($_POST['update_widgetoptions'])) {
	$newoptions = get_option('finojaho');
	foreach ($newoptions as $key => $value) { if (isset($_POST[$key])) { $newoptions[$key] = strip_tags(stripslashes($_POST[$key])); } }
	update_option('finojaho', $newoptions);
	}
	?>
	<p><label><?php _e('Title:','finojaho'); ?></label> 
  	<input name="finojaho_titletwit" id="finojaho_titletwit" type="text" value="<?php echo get_finojaho_option('finojaho_titletwit'); ?>" class="widefat" /></p>

  	<p><label><?php _e('Your Twitter ID:','finojaho'); ?></label>
	<input name="finojaho_twitterid" id="finojaho_twitterid" type="text" value="<?php echo get_finojaho_option('finojaho_twitterid'); ?>"  /></p>

  	<p><label><?php _e('Number of enteries to show:','finojaho'); ?></label>
	<input name="finojaho_twitteren" id="finojaho_twitteren" type="text" value="<?php echo get_finojaho_option('finojaho_twitteren'); ?>" size="3" /></p>	
	
	<input type="hidden" id="update_widgetoptions" name="update_widgetoptions" value="1" />
<?php
}






//-------------------------------------------------------------------------



// Calendar Widget

function finojaho_CalendarWidget($args){
 extract($args);
 echo $before_widget;
 echo $before_title;
 if (get_finojaho_option('finojaho_titlecal') == '') { echo 'Calendar';}
	else { echo get_finojaho_option('finojaho_titlecal');} 
 echo $after_title;
 echo '<ul> <li>';
 get_calendar();
 echo '<span class="spacer"></span></li></ul>';
 echo $after_widget;
}






//-------------------------------------------------------------------------




function finojaho_CalendarWidgetAdmin() {
	// check if anything's been sent
	if (isset($_POST['update_widgetoptions'])) {
	$newoptions = get_option('finojaho');
	foreach ($newoptions as $key => $value) { if (isset($_POST[$key])) { $newoptions[$key] = strip_tags(stripslashes($_POST[$key])); } }
	update_option('finojaho', $newoptions);
	}
	?>
	<p><label><?php _e('Title:','finojaho'); ?></label> 
  	<input name="finojaho_titlecal" id="finojaho_titlecal" type="text" value="<?php echo get_finojaho_option('finojaho_titlecal'); ?>" class="widefat" /></p>
	
	<input type="hidden" id="update_widgetoptions" name="update_widgetoptions" value="1" />
<?php
}






//-------------------------------------------------------------------------




// deregister default widgets
function unregister_problem_widgets() {

if (function_exists('unregister_widget')) {

	unregister_widget('WP_Widget_Pages');
	unregister_widget('WP_Widget_Search');
	unregister_widget('WP_Widget_Archives');
	unregister_widget('WP_Widget_Calendar');
	unregister_widget('WP_Widget_Categories');
	unregister_widget('WP_Widget_Recent_Posts');
	unregister_widget('WP_Widget_Recent_Comments');
		
}

if (function_exists('wp_unregister_sidebar_widget')) {

	wp_unregister_sidebar_widget('Pages');
	wp_unregister_sidebar_widget('search');
	wp_unregister_sidebar_widget('Archives');
	wp_unregister_sidebar_widget('Calendar');	
	wp_unregister_sidebar_widget('Recent-Posts');
	wp_unregister_sidebar_widget('Recent-Comments');	
	
	if ( !$options = get_option( 'widget_categories' ) ) $options = array();
	$id = false;
	foreach ( (array) array_keys($options) as $o ) {
		if ( !isset($options[$o]['title']) )
			continue;
		$id = "categories-$o";
		wp_unregister_sidebar_widget($id);
	}	
	
	
	
}
}





//-------------------------------------------------------------------------



// list pingbacks
function list_pings($comment, $args, $depth) {
 $GLOBALS['comment'] = $comment;
 ?>
 <li id="comment-<?php comment_ID(); ?>"><?php comment_author_link(); ?>
<?php
}





//-------------------------------------------------------------------------




// list comments
function list_comments($comment, $args, $depth) {
 $GLOBALS['comment'] = $comment;
 global $commentcount;
 if(!$commentcount) { $commentcount = 0; }
 ?> <!-- comment entry -->
	<li <?php if (function_exists('comment_class')) { if (function_exists('get_avatar') && get_option('show_avatars')) echo comment_class('with-avatars'); else comment_class(); } else { print 'class="comment';if (function_exists('get_avatar') && get_option('show_avatars')) print ' with-avatars'; print '"';  } ?> id="comment-<?php comment_ID() ?>">

		<div class="commentgrad"> <!-- div commentgrad-->
		<div class="avatar"> <!-- div avatar-->
			<?php if (function_exists('get_avatar') && get_option('show_avatars')): ?>	   
			<?php echo get_avatar($comment, 40); ?>		 
       		<?php endif; ?>		 
			<?php
			if (get_comment_author_url()):
			$authorlink='<a id="commentauthor-'.get_comment_ID().'" href="'.get_comment_author_url().'">'.get_comment_author().'</a>';
			else:
			$authorlink='<b id="commentauthor-'.get_comment_ID().'">'.get_comment_author().'</b>';
			endif;			  
			printf(__('<p>%s</p><span class="extra">%s</span>'), $authorlink, get_comment_time(get_option('date_format')).' - '.get_comment_time(get_option('time_format')));
			?>
		</div><!-- /div avatar-->		
		


		<div class="commentinfono">
		  <?php
		   printf(__('<span class="cmmtno">%s</span>'), '<a href="#comment-'.get_comment_ID().'">'.++$commentcount.'</a>');
		  ?>		  
		</div>			  

		<div class="commentbdr"></div>		


		</div><!-- /div commentgrad-->
		
		
		
        <!-- comment contents -->
        <div class="text"> <!-- div text-->
		 <?php if ($comment->comment_approved == '0'): ?>
		 <p class="error"><small><?php _e('Your comment is awaiting moderation.','finojaho'); ?></small></p>
		 <?php endif; ?>
		 <div id="commentbody-<?php comment_ID() ?>">
          <?php comment_text(); ?>
         </div>
       </div><!-- /div text-->
       <!-- /comment contents -->

   	   <div class="replypart">
        <?php if(comments_open()): ?>
         <?php if (function_exists('comment_reply_link')): ?>
	     <?php comment_reply_link(array_merge( $args, array('add_below' => 'commentbody', 'depth' => $depth, 'max_depth' => $args['max_depth'], 'reply_text' => __('Reply','finojaho')))) ?>
         <?php endif; ?>
        <?php endif; ?>
        <?php edit_comment_link(__('Edit','finojaho'),'',''); ?>
	   </div>

<?php
  } // </li> is added by wordpress
?>
